#include "subprogram.h"
#include "imageviewer.h"

extern vector <Dir> dir;
extern vector <string> dirimage;
extern SDL_Surface *img_text, *img_background, *img_arrow, *img_arrows, *img_dirbuttons, *img_editbuttons, *img_check, *img_doc, *img_dot, *img_folder, *img_music, *img_pic, *img_space, *screen;
extern SDL_Surface *img_rckeys, *img_lckeys, *img_lcskeys, *img_rcskeys, *img_lkeys, *img_rkeys, *img_lskeys, *img_rskeys;
extern SDL_Surface *img_textbackground, *img_menubar, *tmp, *img_view, *img_test, *im_screen;
extern TTF_Font *font, *drawfont, *drawfont10, *drawfont12, *drawfont14, *drawfont16, *systemfont;
extern SDL_Color sdlwhite;
extern SDL_Color sdlblack;
extern SDL_Color sdlgrey;
extern SDL_Color sdldarkgrey;
extern SDL_Color sdlred;
extern SDL_Color sdlgreen;
extern SDL_Color sdlblue;
extern SDL_Color forecol, fgcol, bgcol;
extern Uint32 backcol, white, black, grey, lightgrey, darkgrey, red, green, blue, cursorcol;
extern bool bmUpdate, isplaying, ispaused, padrelease, usb, wordwrap1, wordwrap2, btest, bview;
extern int nLine,nCol,wait;
extern int menu,nKeyset,nFontsize,mode,menucursor,menumode;
extern int dircursor, dirscroll, dirselect, nDir, dirmaxlines, directorymode;	
extern SceCtrlData pad;
extern SceIoDirent g_dir;
extern string photodir;

bool bRot90 = false, bRot180 = false, bScalew = false, bScaleh = false;
int imscrollx = 0, imscrolly = 0, imindex = 0;
float imscalex=1.0, imscaley=1.0;
string imgpath;


void listImageDirectory(string path) {
	int count;
	Dir tmpdir;
	
	int fd = sceIoDopen(path.c_str());
	dirimage.clear();
	while (sceIoDread(fd, &g_dir) > 0) {
		tmpdir.name = g_dir.d_name;
		//tmpdir.size = g_dir.d_stat.st_size;
		tmpdir.isDir = g_dir.d_stat.st_attr & FIO_SO_IFDIR;
		//dir.push_back(tmpdir);
		
		if (is_image(tmpdir.name)) dirimage.push_back(tmpdir.name);
	}
	
	sort(dirimage.begin(), dirimage.end());
}

void initImageViewer(string path, string name) {
	string readfile;
	
	imgpath = path;
	readfile = path + "/" + name;
	listImageDirectory(path);
	imindex = 0;
	while (name != dirimage[imindex]) imindex++;
	imscalex = 1.0;
	imscaley = 0;
	imscrollx = 0;
	imscrolly = 0;
	
	/*
	tmp=IMG_Load(readfile.c_str());
	if(!tmp){img_view = SDL_DisplayFormat(img_doc);}
	else img_view=SDL_DisplayFormat(tmp);						
	SDL_FreeSurface(tmp);
	*/
	if (bview) {
		SDL_FreeSurface(img_view);
		bview = false;
	}
	if (btest) {
		SDL_FreeSurface(img_test);
		bview = false;
	}
	
	if (isplaying) {
		img_test = IMG_Load(readfile.c_str());
		btest = true;
	}
	else
	{
		img_view=IMG_Load(readfile.c_str());
		bview = true;
		img_test=SDL_DisplayFormat(img_view);
		bview = true;
	}
	
	if (!isplaying) 
	{
		if (bScalew) imscalex = 480.0/img_test->w;
		if (bScaleh) imscalex = 272.0/img_test->h;
		if (bRot90) imscaley = 90;
		if (bRot180) imscaley = 180;
		
		if (bScalew || bScaleh || bRot90 || bRot180) {
			SDL_FreeSurface(img_test);
			img_test = sge_transform_surface(img_view, 0, imscaley, imscalex, imscalex, 0);
		}
	}
	if (img_test->w < 480) imscrollx = 240-img_test->w/2;
	if (img_test->h < 272) imscrolly = 136-img_test->h/2;
}

void getImageViewerInput(void) {
	string readfile;
	
	if (pad.Lx == 0) {
		if (img_test->w > 480) {
			if (imscrollx >= 0) imscrollx = 0;
			else {
				if (isplaying && !ispaused) imscrollx+=8;
				else imscrollx+=4;
			}
		}
		bmUpdate = true;
	}
	if (pad.Lx == 255) {
		if (img_test->w > 480) {
			if (img_test->w + imscrollx <= 480) imscrollx = 480-img_test->w;
			else {
				if (isplaying && !ispaused) imscrollx-=8;
				else imscrollx-=4;
			}
		}
		bmUpdate = true;
	}
	if (pad.Ly == 0) {
		if (img_test->h > 272) {
			if (imscrolly >= 0) imscrolly = 0;
			else {
				if (isplaying && !ispaused) imscrolly+=8;
				else imscrolly+=4;
			}
		}
		bmUpdate = true;
	}
	if (pad.Ly == 255) {
		if (img_test->h > 272) {
			if (img_test->h + imscrolly <= 272) imscrolly = 272-img_test->h;
			else {
				if (isplaying && !ispaused) imscrolly-=8;
				else imscrolly-=4;
			}
		}
		bmUpdate = true;
	}

	if (pad.Buttons & PSP_CTRL_UP && padrelease && !isplaying && bview) {
		if (imscalex <= 1.5) imscalex+=0.25;
		SDL_FreeSurface(img_test);
		img_test = sge_transform_surface(img_view, 0, imscaley, imscalex, imscalex, 0);
		imscrollx = 0;
		imscrolly = 0;
		if (img_test) {
			if (img_test->w < 480) imscrollx = 240-img_test->w/2;
			if (img_test->h < 272) imscrolly = 136-img_test->h/2;
		}
		padrelease = false;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN && padrelease && !isplaying && bview) {
		if (imscalex >= 0.5) imscalex-=0.25;
		SDL_FreeSurface(img_test);
		img_test = sge_transform_surface(img_view, 0, imscaley, imscalex, imscalex, 0);
		imscrollx = 0;
		imscrolly = 0;			
		if (img_test) {
			if (img_test->w < 480) imscrollx = 240-img_test->w/2;
			if (img_test->h < 272) imscrolly = 136-img_test->h/2;
		}		
		padrelease = false;
		bmUpdate = true;
	}
	
	
	if (pad.Buttons & PSP_CTRL_LEFT && padrelease && !isplaying && bview) {
		imscaley-=90;
		SDL_FreeSurface(img_test);
		img_test = sge_transform_surface(img_view, 0, imscaley, imscalex, imscalex, 0);
		imscrollx = 0;
		imscrolly = 0;			
		if (img_test) {
			if (img_test->w < 480) imscrollx = 240-img_test->w/2;
			if (img_test->h < 272) imscrolly = 136-img_test->h/2;
		}		
		padrelease = false;
		bmUpdate = true;
	}		

	if (pad.Buttons & PSP_CTRL_RIGHT && padrelease && !isplaying && bview) {
		imscaley+=90;
		SDL_FreeSurface(img_test);
		img_test = sge_transform_surface(img_view, 0, imscaley, imscalex, imscalex, 0);
		imscrollx = 0;
		imscrolly = 0;
		if (img_test) {
			if (img_test->w < 480) imscrollx = 240-img_test->w/2;
			if (img_test->h < 272) imscrolly = 136-img_test->h/2;
		}
		padrelease = false;
		bmUpdate = true;
	}

	
	if (pad.Buttons & PSP_CTRL_LTRIGGER && padrelease) {
		imindex--;
		if (imindex < 0) imindex = dirimage.size() - 1;

		readfile = imgpath + "/" + dirimage[imindex];
		/*
		tmp=IMG_Load(readfile.c_str());
		if(!tmp){img_view = SDL_DisplayFormat(img_doc);}
		else img_view=SDL_DisplayFormat(tmp);
		SDL_FreeSurface(tmp);
		*/
		if (isplaying) 
		{
			SDL_FreeSurface(img_test);
			img_test = IMG_Load(readfile.c_str());
		}
		else
		{
			SDL_FreeSurface(img_test);
			SDL_FreeSurface(img_view);	
			img_view=IMG_Load(readfile.c_str());
			img_test=SDL_DisplayFormat(img_view);
			btest = true;
			bview = true;
		}
		imscrollx = 0;
		imscrolly = 0;
		imscalex = 1.0;
		imscaley = 0;
		if (!isplaying) 
		{
			if (bScalew) imscalex = 480.0/img_view->w;
			if (bScaleh) imscalex = 272.0/img_view->h;
			if (bRot90) imscaley = 90;
			if (bRot180) imscaley = 180;
			if (bScalew || bScaleh || bRot90 || bRot180) {
				SDL_FreeSurface(img_test);
				img_test = sge_transform_surface(img_view, 0, imscaley, imscalex, imscalex, 0);
			}
		}
		if (img_test->w < 480) imscrollx = 240-img_test->w/2;
		if (img_test->h < 272) imscrolly = 136-img_test->h/2;
		wait = 250;
		padrelease = false;
		bmUpdate = true;
	}
	if (pad.Buttons & PSP_CTRL_RTRIGGER && padrelease) {
		imindex++;
		if (imindex == dirimage.size()) imindex = 0;
		
		readfile = imgpath + "/" + dirimage[imindex];
		/*
		tmp=IMG_Load(readfile.c_str());
		if(!tmp){img_view = SDL_DisplayFormat(img_doc);}
		else img_view=SDL_DisplayFormat(tmp);
		SDL_FreeSurface(tmp);
		*/
		if (isplaying) 
		{
			SDL_FreeSurface(img_test);
			img_test = IMG_Load(readfile.c_str());
		}
		else
		{
			SDL_FreeSurface(img_test);
			SDL_FreeSurface(img_view);	
			img_view=IMG_Load(readfile.c_str());
			img_test=SDL_DisplayFormat(img_view);
			btest = true;
			bview = true;
		}
		imscrollx = 0;
		imscrolly = 0;
		imscalex = 1.0;
		imscaley = 0;
		if (!isplaying) 
		{
			if (bScalew) imscalex = 480.0/img_test->w;
			if (bScaleh) imscalex = 272.0/img_test->h;
			if (bRot90) imscaley = 90;
			if (bRot180) imscaley = 180;
			if (bScalew || bScaleh || bRot90 || bRot180) {
				SDL_FreeSurface(img_test);
				img_test = sge_transform_surface(img_view, 0, imscaley, imscalex, imscalex, 0);
			}
		}
		if (img_test->w < 480) imscrollx = 240-img_test->w/2;
		if (img_test->h < 272) imscrolly = 136-img_test->h/2;
		wait = 250;
		padrelease = false;
		bmUpdate = true;
	}
}

void displayImageViewer(SDL_Surface *surface) {
	if (img_test->w < 480 || img_test->h < 272) 
	{
		SDL_FillRect(surface,NULL,black);
	}
	if (img_test) 
	{
		blit(surface, imscrollx, imscrolly,img_test);
	}
}

void getImageViewerMenuInput(void) {
	if (padrelease) {
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			menu = 1;
			menucursor = 1;
			wait = 100;
			padrelease = false;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			menu = 4;
			menucursor = 1;
			wait = 100;
			padrelease = false;
			bmUpdate = true;
		}
	}

	
	if (pad.Buttons & PSP_CTRL_UP) {
		if (menucursor == 1) menucursor = 5;
		else menucursor--;
		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if (menucursor == 5) menucursor = 1;
		else menucursor++;
		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_CROSS) {
		if (menucursor == 1) {
			directorymode = 3;
			listDirectory(photodir);
			menumode = 5;
			nDir = dir.size();
			dircursor = 0;
			dirselect = 0;
			dirscroll = 0;
			padrelease = false;
			menu = 0;			
		}
		if (bview)
		{
			if (menucursor == 2 && !isplaying) {
				bScalew = !bScalew;
				bScaleh = false;
			}
			if (menucursor == 3 && !isplaying) {
				bScaleh = !bScaleh;
				bScalew = false;
			}
			if (menucursor == 4 && !isplaying) {
				bRot90 = !bRot90;
				bRot180 = false;
			}
			if (menucursor == 5 && !isplaying) {
				bRot180 = !bRot180;
				bRot90 = false;
			}
			imscalex = 1.0;
			imscaley = 0;
			imscrollx = 0;
			imscrolly = 0;
			if (bScalew) imscalex = 480.0/img_view->w;
			if (bScaleh) imscalex = 272.0/img_view->h;
			if (bRot90) imscaley = 90;
			if (bRot180) imscaley = 180;
			SDL_FreeSurface(img_test);
			img_test = sge_transform_surface(img_view, 0, imscaley, imscalex, imscalex, 0);
			if (img_test->w < 480) imscrollx = 240-img_test->w/2;
			if (img_test->h < 272) imscrolly = 136-img_test->h/2;	
		}
		menu = 0;
		bmUpdate = true;
	}
}

void displayImageViewerMenu(SDL_Surface *surface) {
	int menupos;
	//time ( &tTime);
	//tmTime = localtime(&tTime);
	//tmTime->tm_hour+=tzHour;
	//if (tmTime->tm_hour > 12) tmTime->tm_hour-=12;
	/*
	drawFillRect(surface,0,0,480,10, grey);
	drawHline(surface,0,0,480, lightgrey);
	drawHline(surface,0,10,480,darkgrey);
	*/
	blit(im_screen, 0,0, img_menubar);
	if (menu == 1) {
		drawFillRect(surface,8,0,32,10,darkgrey);
	}
	if (menu == 3) {
		drawFillRect(surface,58,0,32,10,darkgrey);
	}
	if (menu == 4) {
		drawFillRect(surface,108,0,39,10,darkgrey);
	}	
	if (menu == 5) {
		drawFillRect(surface,158,0,39,10,darkgrey);
	}
	drawText(font,surface,11,0, "File", sdlblack);
	drawText(font,surface,61,0, "View", sdlblack);
	if (isplaying) drawText(font,surface,111,0, "Music", sdlblack);
	else drawText(font,surface,111,0, "Music", sdldarkgrey);	
	drawText(font,surface,161,0, "Image", sdlblack);

	//drawText(font, im_surface, 300,0, asctime(tmTime), sdlblack);
/*	
	if (menu == 1) {
		menupos = 10;
		
		drawText(font,surface,menupos,0, "File", sdlwhite);

		drawDropmenu(surface, menupos, 11, 12, 8);
		
		drawFillRect(surface,menupos+6,menucursor*nLine+4, 4*nCol+nCol*12-8, nLine, blue);

		if (menucursor == 1) drawTextShadowed(font,surface,menupos+20,nLine+4, "New", sdlwhite);
		else drawText(font,surface,menupos+20,nLine+4, "New", sdlblack);
		
		if (menucursor == 2) drawTextShadowed(font,surface,menupos+20,2*nLine+4, "Open", sdlwhite);
		else drawText(font,surface,menupos+20,2*nLine+4, "Open", sdlblack);
		
		if (menucursor == 3) drawTextShadowed(font,surface,menupos+20,3*nLine+4, "Save", sdlwhite);
		else drawText(font,surface,menupos+20,3*nLine+4, "Save", sdlblack);
		
		if (menucursor == 4) {
			drawTextShadowed(font,surface,menupos+20,4*nLine+4, "USB", sdlwhite);
			if (usb) blit(surface,menupos+4,4*nLine+6,img_check);
		}
		else {
			drawText(font,surface,menupos+20,4*nLine+4, "USB", sdlblack);
			if (usb) blit(surface,menupos+4,4*nLine+6,img_check);
		}

		if (menucursor == 5) drawTextShadowed(font,surface,menupos+20,5*nLine+4, "Address Book", sdlwhite);
		else drawText(font,surface,menupos+20,5*nLine+4, "Address Book", sdlblack);
		if (menucursor == 6) drawTextShadowed(font,surface,menupos+20,6*nLine+4, "Calculator", sdlwhite);
		else drawText(font,surface,menupos+20,6*nLine+4, "Calculator", sdlblack);
		if (menucursor == 7) drawTextShadowed(font,surface,menupos+20,7*nLine+4, "Calendar", sdlwhite);
		else drawText(font,surface,menupos+20,7*nLine+4, "Calendar", sdlblack);		
		if (menucursor == 8) drawTextShadowed(font,surface,menupos+20,8*nLine+4, "Exit", sdlwhite);
		else drawText(font,surface,menupos+20,8*nLine+4, "Exit", sdlblack);
	}
	
	if (menu == 3) {
		if (mode < 4) menupos = 110;
		if (mode >= 4) menupos = 60;
		drawText(font,surface,menupos,0, "View", sdlwhite);

		drawDropmenu(surface, menupos, 11, 16, 8);
		
		drawFillRect(surface,menupos+6,menucursor*nLine+4, 4*nCol+nCol*16-8, nLine, blue);		
		
		if (menucursor == 1) drawTextShadowed(font,surface,menupos+20, nLine+4, "Full surface", sdlwhite);
		else drawText(font,surface,menupos+20, nLine+4, "Full surface", sdlblack);
		
		if (menucursor == 2) {
			drawTextShadowed(font,surface,menupos+20,2*nLine+4, "Keyboard 1", sdlwhite);
			if (nKeyset == 1) blit(surface,menupos+4,2*nLine+6,img_check);
		}
		else {
			drawText(font,surface,menupos+20,2*nLine+4, "Keyboard 1", sdlblack);
			if (nKeyset == 1) blit(surface,menupos+4,2*nLine+6,img_check);
		}
		if (menucursor == 3) {
			drawTextShadowed(font,surface,menupos+20,3*nLine+4, "Word Wrap 1", sdlwhite);
			if (wordwrap1) blit(surface,menupos+4,3*nLine+6,img_check);
		}
		else {
			drawText(font,surface,menupos+20,3*nLine+4, "Word Wrap 1", sdlblack);
			if (wordwrap1) blit(surface,menupos+4,3*nLine+6,img_check);
		}
		if (menucursor == 4) {
			drawTextShadowed(font,surface,menupos+20,4*nLine+4, "Word Wrap 2", sdlwhite);
			if (wordwrap2) blit(surface,menupos+4,4*nLine+6,img_check);
		}
		else {
			drawText(font,surface,menupos+20,4*nLine+4, "Word Wrap 2", sdlblack);
			if (wordwrap2) blit(surface,menupos+4,4*nLine+6,img_check);
		}
		if (menucursor == 5) {
			if (nFontsize > 10) drawTextShadowed(font,surface,menupos+20,5*nLine+4, "Font Size -", sdlwhite);
			else drawText(font,surface,menupos+20,5*nLine+4, "Font Size -", sdlgrey);
		}
		else {
			if (nFontsize > 10) drawText(font,surface,menupos+20,5*nLine+4, "Font Size -", sdlblack);
			else drawText(font,surface,menupos+20,5*nLine+4, "Font Size -", sdlgrey);
		}
		if (menucursor == 6) {
			if (nFontsize < 16) drawTextShadowed(font,surface,menupos+20,6*nLine+4, "Font Size +", sdlwhite);
			else drawText(font,surface,menupos+20,6*nLine+4, "Font Size +", sdlgrey);
		}
		else {
			if (nFontsize < 16) drawText(font,surface,menupos+20,6*nLine+4, "Font Size +", sdlblack);
			else drawText(font,surface,menupos+20,6*nLine+4, "Font Size +", sdlgrey);
		}
		if (menucursor == 7) drawTextShadowed(font,surface, menupos+20,7*nLine+4, "Background Color", sdlwhite);
		else drawText(font,surface,menupos+20,7*nLine+4,"Background Color", sdlblack);
		if (menucursor == 8) drawTextShadowed(font,surface, menupos+20,8*nLine+4, "Text Color", sdlwhite);
		else drawText(font,surface,menupos+20,8*nLine+4,"Text Color", sdlblack);			
	}
	*/
	if (menu == 5) {
		menupos = 160;
		
		drawText(font,surface,menupos,0, "Image", sdlwhite);

		drawDropmenu(surface, menupos, 11, 18, 5);
		
		drawFillRect(surface,menupos+6,menucursor*nLine+4, 4*nCol+nCol*18-8, nLine, blue);
		
		if (menucursor == 1) {
			drawTextShadowed(font,surface,menupos+20,nLine+4, "Open", sdlwhite);
		}
		else {
			drawText(font,surface,menupos+20,nLine+4, "Open", sdlblack);
		}
		if (menucursor == 2) {
			drawTextShadowed(font,surface,menupos+20,2*nLine+4, "Scale to surface W", sdlwhite);
			if (bScalew) blit(surface,menupos+4,2*nLine+6,img_check);
		}
		else {
			drawText(font,surface,menupos+20,2*nLine+4, "Scale to surface W", sdlblack);
			if (bScalew) blit(surface,menupos+4,2*nLine+6,img_check);
		}
		
		if (menucursor == 3) {
			drawTextShadowed(font,surface,menupos+20,3*nLine+4, "Scale to surface H", sdlwhite);
			if (bScaleh) blit(surface,menupos+4,3*nLine+6,img_check);
		}
		else {
			drawText(font,surface,menupos+20,3*nLine+4, "Scale to surface H", sdlblack);
			if (bScaleh) blit(surface,menupos+4,3*nLine+6,img_check);
		}
		
		if (menucursor == 4) {
			drawTextShadowed(font,surface,menupos+20,4*nLine+4, "Rotate 90", sdlwhite);
			if (bRot90) blit(surface,menupos+4,4*nLine+6,img_check);
		}
		else {
			drawText(font,surface,menupos+20,4*nLine+4, "Rotate 90", sdlblack);
			if (bRot90) blit(surface,menupos+4,4*nLine+6,img_check);
		}
		if (menucursor == 5) {
			drawTextShadowed(font,surface,menupos+20,5*nLine+4, "Rotate 180", sdlwhite);
			if (bRot180) blit(surface,menupos+4,5*nLine+6,img_check);
		}
		else {
			drawText(font,surface,menupos+20,5*nLine+4, "Rotate 180", sdlblack);
			if (bRot180) blit(surface,menupos+4,5*nLine+6,img_check);
		}
	}	

}

